////////////////////////////////////////////////////////////////////////////////
// OLE Automation for XML with Delphi
// demonstration
// fabrice.marguerie@cogisoft.fr
// http://www.cogisoft.fr/downloads
// 22/04/1999
////////////////////////////////////////////////////////////////////////////////

unit DemoXMLAuto_frm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  MSXML_TLB, ExtCtrls;

type
  TfrmDemoXMLAuto = class(TForm)
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    btnWrite: TButton;
    btnLoad: TButton;
    btnRead: TButton;
    procedure btnLoadClick(Sender: TObject);
    procedure btnWriteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnReadClick(Sender: TObject);
  private
  public
  end;

var
  frmDemoXMLAuto: TfrmDemoXMLAuto;

implementation

{$R *.DFM}

uses
  XMLAuto;

var
  Document: IXMLDOMDocument;
  vDocument: Variant;

////////////////////////////////////////////////////////////////////////////////
//  TForm1
////////////////////////////////////////////////////////////////////////////////

procedure TfrmDemoXMLAuto.FormCreate(Sender: TObject);
begin
  Document := CoDOMDocument.Create;
  vDocument := Document;
  try
    Memo1.Lines.LoadFromFile(ExtractFilePath(Application.ExeName)+'Books.xml');
    Document.LoadXML(Memo1.Text);
  except

  end;
end;

procedure TfrmDemoXMLAuto.btnLoadClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
    Document.LoadXML(Memo1.Text);
  end;
end;

procedure TfrmDemoXMLAuto.btnReadClick(Sender: TObject);
begin
  // defaultconfiguration
  SetXMLAutoProperties([xpAutoCreateElement, xpEnableDefaultProperty], False);
  SetXMLAutoProperty(xpEnableDOM, True);

  // simple read
  ShowMessage(vDocument.bookstore.book.author.last_name.text);

  // EnableDOM
  SetXMLAutoProperty(xpEnableDOM, True);
  ShowMessage(vDocument.bookstore.childNodes[1].author.last_name.text);

  // collection
  ShowMessage(vDocument.bookstore.book[1].author.last_name.text);

  // EnableDefaultProperty
  SetXMLAutoProperty(xpEnableDefaultProperty, True);
  ShowMessage(vDocument.bookstore.book.author.last_name);
end;

procedure TfrmDemoXMLAuto.btnWriteClick(Sender: TObject);
begin
  // EnableDOM
  SetXMLAutoProperty(xpAutoCreateElement, False);
  SetXMLAutoProperty(xpEnableDefaultProperty, False);
  SetXMLAutoProperty(xpEnableDOM, True);
  vDocument.bookstore.book.title.text := 'test write 1';

  // AutoCreateElement
  SetXMLAutoProperty(xpAutoCreateElement, True);
  SetXMLAutoProperty(xpEnableDefaultProperty, False);
  SetXMLAutoProperty(xpEnableDOM, False);
  vDocument.bookstore.test1.text := 'test write 2';

  // EnableDefaultProperty
  SetXMLAutoProperty(xpAutoCreateElement, False);
  SetXMLAutoProperty(xpEnableDefaultProperty, True);
  SetXMLAutoProperty(xpEnableDOM, False);
  vDocument.bookstore.test1 := 'test write 3';

  // AutoCreateElement & EnableDefaultProperty
  SetXMLAutoProperties([xpAutoCreateElement, xpEnableDefaultProperty, xpEnableDOM],
      True);
  vDocument.bookstore.test2 := 'test write 4';
  vDocument.bookstore.test2[1] := 'test write 5';

  // display
  Memo1.Lines.Text := Document.xml;
end;

end.
