////////////////////////////////////////////////////////////////////////////////
// OLE Automation for Strings with Delphi
// StringsAuto.pas
// fabrice.marguerie@cogisoft.fr
// http://www.cogisoft.fr/downloads
// 22/04/1999
////////////////////////////////////////////////////////////////////////////////

unit StringsAuto;

interface

uses
  ComObj, Classes;

type
  TVarDispProc = procedure (Result: PVariant; const Instance: Variant;
      CallDesc: PCallDesc; Params: Pointer); cdecl;

var
  OldVarDispProc: TVarDispProc = nil;

function CreateStringsVariant(Strings: TStrings): Variant;


implementation


uses
  Windows, ActiveX, SysUtils;


function CreateStringsVariant(Strings: TStrings): Variant;
begin
  TVarData(Result).VType := vtObject;
  TVarData(Result).VPointer := Strings;
end;

procedure VarDispInvoke(Result: PVariant; const Instance: Variant;
    CallDesc: PCallDesc; Params: Pointer); cdecl;
resourcestring
  SStringValueExpectedErr = 'String value expected';
const
  atTypeMask = $7F;
  varStrArg = $0048;
var
  LastArgType: Integer;
  LastParamPtr: Pointer;
  Name: string;
  Obj: TObject;
  Strings: TStrings;
begin
  // retrieve object or default processing
  Obj := TVarData(Instance).VPointer;
  if (TVarData(Instance).VType <> vtObject) or (not (Obj is TStrings)) then
  begin
    // default
    OldVarDispProc(Result, Instance, CallDesc, Params);
    Exit;
  end;
  Strings := TStrings(Obj);

  Name := PChar(@CallDesc^.ArgTypes[CallDesc^.ArgCount]);

  // handle property put
  if CallDesc^.CallType = DISPATCH_PROPERTYPUT then
  begin
    LastArgType := CallDesc^.ArgTypes[CallDesc^.ArgCount-1] and atTypeMask;
    LastParamPtr := Pointer(Integer(@Params) + (CallDesc^.ArgCount-1)*SizeOf(Pointer));

    if LastArgType <> varStrArg then
      raise Exception.Create(SStringValueExpectedErr);
    Strings.Values[Name] := PString(LastParamPtr)^;
  end;

  // handle get
  if Result <> nil then
    Result^ := Strings.Values[Name];
end;


initialization
  OldVarDispProc := VarDispProc;
  VarDispProc := @VarDispInvoke;
finalization
  VarDispProc := @OldVarDispProc;
end.
